// FILE. . . . . /home/hak/hlt/src/hlt/osfv2/base/AndSortExpression.java
// EDIT BY . . . Hassan Ait-Kaci
// ON MACHINE. . Hak-Laptop
// STARTED ON. . Tue Jan 21 08:02:18 2014

/**
 * @version     Last modified on Tue Jan 21 08:04:40 2014 by hak
 * @author      <a href="mailto:hak@acm.org">Hassan A&iuml;t-Kaci</a>
 * @copyright   &copy; <a href="http://www.hassan-ait-kaci.net/">by the author</a>
 */

package hlt.osf.base;

/**
 * This is the class of an 'and' sort expression. It consists of two
 * sort expressions which are its arguments.
 */
public class AndSortExpression extends BinarySortExpression
  {
    public AndSortExpression (SortExpression lhs, SortExpression rhs)
    {
      super(lhs,rhs);
      _context = lhs.context();
    }

    public byte type ()
    {
      return _context.AND();
    }

    public String displayForm ()
    {
      String form = _lhs.displayForm() + " & " + _rhs.displayForm();
      return isParenthesized() ? "("+form+")" : form;
    }

    public boolean equals (Object other)
    {
      if (!(other instanceof AndSortExpression))
	return false;

      AndSortExpression o = (AndSortExpression)other;
      
      return _lhs.equals(o.lhs()) && _rhs.equals(o.rhs())
          || _rhs.equals(o.rhs()) && _lhs.equals(o.lhs());
    }

  }
